export declare class LinkedListNode<T> {
    value: T;
    next: LinkedListNode<T> | null;
    prev: LinkedListNode<T> | null;
    constructor(value: T);
}
export declare class LinkedList<T> {
    private head;
    private tail;
    count: number;
    get first(): LinkedListNode<T> | null;
    get last(): LinkedListNode<T> | null;
    addFirst(value: T): LinkedListNode<T>;
    addLast(value: T): LinkedListNode<T>;
    remove(node: LinkedListNode<T>): void;
    removeFirst(): void;
    removeLast(): void;
    valuesForwards(): {
        [Symbol.iterator](): Generator<T, void, unknown>;
    };
    valuesBackwards(): {
        [Symbol.iterator](): Generator<T, void, unknown>;
    };
}
