export class PromiseCancel {
    constructor() {
        this.assign();
    }
    cancelResolve(value) {
        this.resolve(value);
        this.assign();
    }
    cancelReject(reason) {
        this.reject(reason);
        this.assign();
    }
    race(...promises) {
        return Promise.race([this.promise, ...promises]);
    }
    assign() {
        this.promise = new Promise((resolve, reject) => {
            this.resolve = resolve;
            this.reject = reject;
        });
    }
}
