import { Rule } from '../composition/useValidation';
import { FormField } from './FormField';
declare type ValidateResult = void | string;
export declare class Form {
    private simpleMap;
    private keyedSetMap;
    private reactiveFormFieldMap;
    private trySetKeyedSet;
    private tryGetKeyedSet;
    private tryGetSimple;
    submitting: import("vue").Ref<boolean>;
    errors: import("vue").ComputedRef<string[]>;
    registerField(uid: number, name: string, modelValue: unknown, rules: Rule[]): FormField;
    validate(uid: number): Promise<PromiseSettledResult<ValidateResult>[]> | undefined;
    validateAll(names?: (string | number | symbol)[]): Promise<void>;
    onDelete(uid: number): void;
    resetFields(toDefaultValues?: boolean): void;
    private getPromisesForKeys;
    private getPromisesForNames;
    private isEveryFormFieldTouchedWith;
    private static validateFactory;
}
export {};
